Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.linear
Interface RealMatrix

All Superinterfaces:
  AnyMatrix

All Known Subinterfaces:
  SparseRealMatrix

All Known Implementing Classes:
  AbstractRealMatrix, Array2DRowRealMatrix, BlockRealMatrix, OpenMapRealMatrix, RealMatrixImpl

    public interface RealMatrix

extends AnyMatrix

Interface defining a real-valued matrix with basic algebraic operations.

Matrix element indexing is 0-based -- e.g., `getEntry(0, 0)` returns the element in the first row, first column of the matrix.

Version:
  $Revision: 1073158 $ $Date: 2011-02-21 22:46:52 +0100 (lun. 21 fÃ©vr. 2011) $

Method Summary
`RealMatrix` | `add(RealMatrix m)` Compute the sum of this and m.
`void` | `addToEntry(int row, int column, double increment)` Change an entry in the specified row and column.
`RealMatrix` | `copy()` Returns a (deep) copy of this.
`void` | `copySubMatrix(int[] selectedRows, int[] selectedColumns, double[][] destination)` Copy a submatrix.
`void` | `copySubMatrix(int startRow, int endRow, int startColumn, int endColumn, double[][] destination)` Copy a submatrix.
`RealMatrix` | `createMatrix(int rowDimension, int columnDimension)` Create a new RealMatrix of the same type as the instance with the supplied row and column dimensions.
`double[]` | `getColumn(int column)` Returns the entries in column number `col` as an array.
`RealMatrix` | `getColumnMatrix(int column)` Returns the entries in column number `column` as a column matrix.
`RealVector` | `getColumnVector(int column)` Returns the entries in column number `column` as a vector.
`double[][]` | `getData()` Returns matrix entries as a two-dimensional array.
`double` | `getDeterminant()` Deprecated. as of release 2.0, replaced by ``new LUDecompositionImpl(m)`.`getDeterminant()``
`double` | `getEntry(int row, int column)` Returns the entry in the specified row and column.
`double` | `getFrobeniusNorm()` Returns the Frobenius norm of the matrix.
`double` | `getNorm()` Returns the maximum absolute row sum norm of the matrix.
`double[]` | `getRow(int row)` Returns the entries in row number `row` as an array.
`RealMatrix` | `getRowMatrix(int row)` Returns the entries in row number `row` as a row matrix.
`RealVector` | `getRowVector(int row)` Returns the entries in row number `row` as a vector.
`RealMatrix` | `getSubMatrix(int[] selectedRows, int[] selectedColumns)` Gets a submatrix.
`RealMatrix` | `getSubMatrix(int startRow, int endRow, int startColumn, int endColumn)` Gets a submatrix.
`double` | `getTrace()` Returns the trace of the matrix (the sum of the elements on the main diagonal).
`RealMatrix` | `inverse()` Deprecated. as of release 2.0, replaced by ``new LUDecompositionImpl(m)`.`getSolver()`.`getInverse()``
`boolean` | `isSingular()` Deprecated. as of release 2.0, replaced by the boolean negation of ``new LUDecompositionImpl(m)`.`getSolver()`.`isNonSingular()``
`RealMatrix` | `multiply(RealMatrix m)` Returns the result of postmultiplying this by m.
`void` | `multiplyEntry(int row, int column, double factor)` Change an entry in the specified row and column.
`double[]` | `operate(double[] v)` Returns the result of multiplying this by the vector `v`.
`RealVector` | `operate(RealVector v)` Returns the result of multiplying this by the vector `v`.
`double[]` | `preMultiply(double[] v)` Returns the (row) vector result of premultiplying this by the vector `v`.
`RealMatrix` | `preMultiply(RealMatrix m)` Returns the result premultiplying this by `m`.
`RealVector` | `preMultiply(RealVector v)` Returns the (row) vector result of premultiplying this by the vector `v`.
`RealMatrix` | `scalarAdd(double d)` Returns the result of adding d to each entry of this.
`RealMatrix` | `scalarMultiply(double d)` Returns the result multiplying each entry of this by d.
`void` | `setColumn(int column, double[] array)` Sets the entries in column number `column` as a column matrix.
`void` | `setColumnMatrix(int column, RealMatrix matrix)` Sets the entries in column number `column` as a column matrix.
`void` | `setColumnVector(int column, RealVector vector)` Sets the entries in column number `column` as a vector.
`void` | `setEntry(int row, int column, double value)` Set the entry in the specified row and column.
`void` | `setRow(int row, double[] array)` Sets the entries in row number `row` as a row matrix.
`void` | `setRowMatrix(int row, RealMatrix matrix)` Sets the entries in row number `row` as a row matrix.
`void` | `setRowVector(int row, RealVector vector)` Sets the entries in row number `row` as a vector.
`void` | `setSubMatrix(double[][] subMatrix, int row, int column)` Replace the submatrix starting at `row, column` using data in the input `subMatrix` array.
`double[]` | `solve(double[] b)` Deprecated. as of release 2.0, replaced by `DecompositionSolver.solve(double[])`
`RealMatrix` | `solve(RealMatrix b)` Deprecated. as of release 2.0, replaced by `DecompositionSolver.solve(RealMatrix)`
`RealMatrix` | `subtract(RealMatrix m)` Compute this minus m.
`RealMatrix` | `transpose()` Returns the transpose of this matrix.
`double` | `walkInColumnOrder(RealMatrixChangingVisitor visitor)` Visit (and possibly change) all matrix entries in column order.
`double` | `walkInColumnOrder(RealMatrixChangingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in column order.
`double` | `walkInColumnOrder(RealMatrixPreservingVisitor visitor)` Visit (but don't change) all matrix entries in column order.
`double` | `walkInColumnOrder(RealMatrixPreservingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in column order.
`double` | `walkInOptimizedOrder(RealMatrixChangingVisitor visitor)` Visit (and possibly change) all matrix entries using the fastest possible order.
`double` | `walkInOptimizedOrder(RealMatrixChangingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries using the fastest possible order.
`double` | `walkInOptimizedOrder(RealMatrixPreservingVisitor visitor)` Visit (but don't change) all matrix entries using the fastest possible order.
`double` | `walkInOptimizedOrder(RealMatrixPreservingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries using the fastest possible order.
`double` | `walkInRowOrder(RealMatrixChangingVisitor visitor)` Visit (and possibly change) all matrix entries in row order.
`double` | `walkInRowOrder(RealMatrixChangingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in row order.
`double` | `walkInRowOrder(RealMatrixPreservingVisitor visitor)` Visit (but don't change) all matrix entries in row order.
`double` | `walkInRowOrder(RealMatrixPreservingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in row order.

Methods inherited from interface org.apache.commons.math.linear.AnyMatrix
`getColumnDimension, getRowDimension, isSquare`

Method Detail

### createMatrix

    RealMatrix createMatrix(int rowDimension,
                            int columnDimension)

  Create a new RealMatrix of the same type as the instance with the supplied row and column dimensions.

  Parameters:
    `rowDimension` - the number of rows in the new matrix
    `columnDimension` - the number of columns in the new matrix
  Returns:
    a new matrix of the same type as the instance
  Throws:
    `IllegalArgumentException` - if row or column dimension is not positive
  Since:
    2.0

### copy

    RealMatrix copy()

  Returns a (deep) copy of this.

  Returns:
    matrix copy

### add

    RealMatrix add(RealMatrix m)
                   throws IllegalArgumentException

  Compute the sum of this and m.

  Parameters:
    `m` - matrix to be added
  Returns:
    this + m
  Throws:
    `IllegalArgumentException` - if m is not the same size as this

### subtract

    RealMatrix subtract(RealMatrix m)
                        throws IllegalArgumentException

  Compute this minus m.

  Parameters:
    `m` - matrix to be subtracted
  Returns:
    this - m
  Throws:
    `IllegalArgumentException` - if m is not the same size as this

### scalarAdd

    RealMatrix scalarAdd(double d)

  Returns the result of adding d to each entry of this.

  Parameters:
    `d` - value to be added to each entry
  Returns:
    d + this

### scalarMultiply

    RealMatrix scalarMultiply(double d)

  Returns the result multiplying each entry of this by d.

  Parameters:
    `d` - value to multiply all entries by
  Returns:
    d * this

### multiply

    RealMatrix multiply(RealMatrix m)
                        throws IllegalArgumentException

  Returns the result of postmultiplying this by m.

  Parameters:
    `m` - matrix to postmultiply by
  Returns:
    this * m
  Throws:
    `IllegalArgumentException` - if columnDimension(this) != rowDimension(m)

### preMultiply

    RealMatrix preMultiply(RealMatrix m)
                           throws IllegalArgumentException

  Returns the result premultiplying this by `m`.

  Parameters:
    `m` - matrix to premultiply by
  Returns:
    m * this
  Throws:
    `IllegalArgumentException` - if rowDimension(this) != columnDimension(m)

### getData

    double[][] getData()

  Returns matrix entries as a two-dimensional array.

  Returns:
    2-dimensional array of entries

### getNorm

    double getNorm()

  Returns the maximum absolute row sum norm of the matrix.

  Returns:
    norm

### getFrobeniusNorm

    double getFrobeniusNorm()

  Returns the Frobenius norm of the matrix.

  Returns:
    norm

### getSubMatrix

    RealMatrix getSubMatrix(int startRow,
                            int endRow,
                            int startColumn,
                            int endColumn)
                            throws MatrixIndexException

  Gets a submatrix. Rows and columns are indicated counting from 0 to n-1.

  Parameters:
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index (inclusive)
  Returns:
    The subMatrix containing the data of the specified rows and columns
  Throws:
    `MatrixIndexException` - if the indices are not valid

### getSubMatrix

    RealMatrix getSubMatrix(int[] selectedRows,
                            int[] selectedColumns)
                            throws MatrixIndexException

  Gets a submatrix. Rows and columns are indicated counting from 0 to n-1.

  Parameters:
    `selectedRows` - Array of row indices.
    `selectedColumns` - Array of column indices.
  Returns:
    The subMatrix containing the data in the specified rows and columns
  Throws:
    `MatrixIndexException` - if row or column selections are not valid

### copySubMatrix

    void copySubMatrix(int startRow,
                       int endRow,
                       int startColumn,
                       int endColumn,
                       double[][] destination)
                       throws MatrixIndexException,
                              IllegalArgumentException

  Copy a submatrix. Rows and columns are indicated counting from 0 to n-1.

  Parameters:
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index (inclusive)
    `destination` - The arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used)
  Throws:
    `MatrixIndexException` - if the indices are not valid
    `IllegalArgumentException` - if the destination array is too small

### copySubMatrix

    void copySubMatrix(int[] selectedRows,
                       int[] selectedColumns,
                       double[][] destination)
                       throws MatrixIndexException,
                              IllegalArgumentException

  Copy a submatrix. Rows and columns are indicated counting from 0 to n-1.

  Parameters:
    `selectedRows` - Array of row indices.
    `selectedColumns` - Array of column indices.
    `destination` - The arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used)
  Throws:
    `MatrixIndexException` - if the indices are not valid
    `IllegalArgumentException` - if the destination array is too small

### setSubMatrix

    void setSubMatrix(double[][] subMatrix,
                      int row,
                      int column)
                      throws MatrixIndexException

  Replace the submatrix starting at `row, column` using data in the input `subMatrix` array. Indexes are 0-based.

  Example:
  Starting with

       1  2  3  4
       5  6  7  8
       9  0  1  2

  and `subMatrix = {{3, 4} {5,6}}`, invoking `setSubMatrix(subMatrix,1,1))` will result in

       1  2  3  4
       5  3  4  8
       9  5  6  2

  Parameters:
    `subMatrix` - array containing the submatrix replacement data
    `row` - row coordinate of the top, left element to be replaced
    `column` - column coordinate of the top, left element to be replaced
  Throws:
    `MatrixIndexException` - if subMatrix does not fit into this matrix from element in (row, column)
    `IllegalArgumentException` - if `subMatrix` is not rectangular (not all rows have the same length) or empty
    `NullPointerException` - if `subMatrix` is null
  Since:
    2.0

### getRowMatrix

    RealMatrix getRowMatrix(int row)
                            throws MatrixIndexException

  Returns the entries in row number `row` as a row matrix. Row indices start at 0.

  Parameters:
    `row` - the row to be fetched
  Returns:
    row matrix
  Throws:
    `MatrixIndexException` - if the specified row index is invalid

### setRowMatrix

    void setRowMatrix(int row,
                      RealMatrix matrix)
                      throws MatrixIndexException,
                             InvalidMatrixException

  Sets the entries in row number `row` as a row matrix. Row indices start at 0.

  Parameters:
    `row` - the row to be set
    `matrix` - row matrix (must have one row and the same number of columns as the instance)
  Throws:
    `MatrixIndexException` - if the specified row index is invalid
    `InvalidMatrixException` - if the matrix dimensions do not match one instance row

### getColumnMatrix

    RealMatrix getColumnMatrix(int column)
                               throws MatrixIndexException

  Returns the entries in column number `column` as a column matrix. Column indices start at 0.

  Parameters:
    `column` - the column to be fetched
  Returns:
    column matrix
  Throws:
    `MatrixIndexException` - if the specified column index is invalid

### setColumnMatrix

    void setColumnMatrix(int column,
                         RealMatrix matrix)
                         throws MatrixIndexException,
                                InvalidMatrixException

  Sets the entries in column number `column` as a column matrix. Column indices start at 0.

  Parameters:
    `column` - the column to be set
    `matrix` - column matrix (must have one column and the same number of rows as the instance)
  Throws:
    `MatrixIndexException` - if the specified column index is invalid
    `InvalidMatrixException` - if the matrix dimensions do not match one instance column

### getRowVector

    RealVector getRowVector(int row)
                            throws MatrixIndexException

  Returns the entries in row number `row` as a vector. Row indices start at 0.

  Parameters:
    `row` - the row to be fetched
  Returns:
    row vector
  Throws:
    `MatrixIndexException` - if the specified row index is invalid

### setRowVector

    void setRowVector(int row,
                      RealVector vector)
                      throws MatrixIndexException,
                             InvalidMatrixException

  Sets the entries in row number `row` as a vector. Row indices start at 0.

  Parameters:
    `row` - the row to be set
    `vector` - row vector (must have the same number of columns as the instance)
  Throws:
    `MatrixIndexException` - if the specified row index is invalid
    `InvalidMatrixException` - if the vector dimension does not match one instance row

### getColumnVector

    RealVector getColumnVector(int column)
                               throws MatrixIndexException

  Returns the entries in column number `column` as a vector. Column indices start at 0.

  Parameters:
    `column` - the column to be fetched
  Returns:
    column vector
  Throws:
    `MatrixIndexException` - if the specified column index is invalid

### setColumnVector

    void setColumnVector(int column,
                         RealVector vector)
                         throws MatrixIndexException,
                                InvalidMatrixException

  Sets the entries in column number `column` as a vector. Column indices start at 0.

  Parameters:
    `column` - the column to be set
    `vector` - column vector (must have the same number of rows as the instance)
  Throws:
    `MatrixIndexException` - if the specified column index is invalid
    `InvalidMatrixException` - if the vector dimension does not match one instance column

### getRow

    double[] getRow(int row)
                    throws MatrixIndexException

  Returns the entries in row number `row` as an array.

  Row indices start at 0. A `MatrixIndexException` is thrown unless `0 <= row < rowDimension.`

  Parameters:
    `row` - the row to be fetched
  Returns:
    array of entries in the row
  Throws:
    `MatrixIndexException` - if the specified row index is not valid

### setRow

    void setRow(int row,
                double[] array)
                throws MatrixIndexException,
                       InvalidMatrixException

  Sets the entries in row number `row` as a row matrix. Row indices start at 0.

  Parameters:
    `row` - the row to be set
    `array` - row matrix (must have the same number of columns as the instance)
  Throws:
    `MatrixIndexException` - if the specified row index is invalid
    `InvalidMatrixException` - if the array size does not match one instance row

### getColumn

    double[] getColumn(int column)
                       throws MatrixIndexException

  Returns the entries in column number `col` as an array.

  Column indices start at 0. A `MatrixIndexException` is thrown unless `0 <= column < columnDimension.`

  Parameters:
    `column` - the column to be fetched
  Returns:
    array of entries in the column
  Throws:
    `MatrixIndexException` - if the specified column index is not valid

### setColumn

    void setColumn(int column,
                   double[] array)
                   throws MatrixIndexException,
                          InvalidMatrixException

  Sets the entries in column number `column` as a column matrix. Column indices start at 0.

  Parameters:
    `column` - the column to be set
    `array` - column array (must have the same number of rows as the instance)
  Throws:
    `MatrixIndexException` - if the specified column index is invalid
    `InvalidMatrixException` - if the array size does not match one instance column

### getEntry

    double getEntry(int row,
                    int column)
                    throws MatrixIndexException

  Returns the entry in the specified row and column.

  Row and column indices start at 0 and must satisfy

  - `0 <= row < rowDimension`
  - `0 <= column < columnDimension`
  otherwise a `MatrixIndexException` is thrown.

  Parameters:
    `row` - row location of entry to be fetched
    `column` - column location of entry to be fetched
  Returns:
    matrix entry in row,column
  Throws:
    `MatrixIndexException` - if the row or column index is not valid

### setEntry

    void setEntry(int row,
                  int column,
                  double value)
                  throws MatrixIndexException

  Set the entry in the specified row and column.

  Row and column indices start at 0 and must satisfy

  - `0 <= row < rowDimension`
  - `0 <= column < columnDimension`
  otherwise a `MatrixIndexException` is thrown.

  Parameters:
    `row` - row location of entry to be set
    `column` - column location of entry to be set
    `value` - matrix entry to be set in row,column
  Throws:
    `MatrixIndexException` - if the row or column index is not valid
  Since:
    2.0

### addToEntry

    void addToEntry(int row,
                    int column,
                    double increment)
                    throws MatrixIndexException

  Change an entry in the specified row and column.

  Row and column indices start at 0 and must satisfy

  - `0 <= row < rowDimension`
  - `0 <= column < columnDimension`
  otherwise a `MatrixIndexException` is thrown.

  Parameters:
    `row` - row location of entry to be set
    `column` - column location of entry to be set
    `increment` - value to add to the current matrix entry in row,column
  Throws:
    `MatrixIndexException` - if the row or column index is not valid
  Since:
    2.0

### multiplyEntry

    void multiplyEntry(int row,
                       int column,
                       double factor)
                       throws MatrixIndexException

  Change an entry in the specified row and column.

  Row and column indices start at 0 and must satisfy

  - `0 <= row < rowDimension`
  - `0 <= column < columnDimension`
  otherwise a `MatrixIndexException` is thrown.

  Parameters:
    `row` - row location of entry to be set
    `column` - column location of entry to be set
    `factor` - multiplication factor for the current matrix entry in row,column
  Throws:
    `MatrixIndexException` - if the row or column index is not valid
  Since:
    2.0

### transpose

    RealMatrix transpose()

  Returns the transpose of this matrix.

  Returns:
    transpose matrix

### inverse

    @Deprecated
    RealMatrix inverse()
                       throws InvalidMatrixException

  Deprecated. as of release 2.0, replaced by ``new LUDecompositionImpl(m)`.`getSolver()`.`getInverse()``

  Returns the inverse of this matrix.

  Returns:
    inverse matrix
  Throws:
    `InvalidMatrixException` - if this is not invertible

### getDeterminant

    @Deprecated
    double getDeterminant()

  Deprecated. as of release 2.0, replaced by ``new LUDecompositionImpl(m)`.`getDeterminant()``

  Returns the determinant of this matrix.

  Returns:
    determinant

### isSingular

    @Deprecated
    boolean isSingular()

  Deprecated. as of release 2.0, replaced by the boolean negation of ``new LUDecompositionImpl(m)`.`getSolver()`.`isNonSingular()``

  Is this a singular matrix?

  Returns:
    true if the matrix is singular

### getTrace

    double getTrace()
                    throws NonSquareMatrixException

  Returns the trace of the matrix (the sum of the elements on the main diagonal).

  Returns:
    trace
  Throws:
    `NonSquareMatrixException` - if the matrix is not square

### operate

    double[] operate(double[] v)
                     throws IllegalArgumentException

  Returns the result of multiplying this by the vector `v`.

  Parameters:
    `v` - the vector to operate on
  Returns:
    this*v
  Throws:
    `IllegalArgumentException` - if columnDimension != v.size()

### operate

    RealVector operate(RealVector v)
                       throws IllegalArgumentException

  Returns the result of multiplying this by the vector `v`.

  Parameters:
    `v` - the vector to operate on
  Returns:
    this*v
  Throws:
    `IllegalArgumentException` - if columnDimension != v.size()

### preMultiply

    double[] preMultiply(double[] v)
                         throws IllegalArgumentException

  Returns the (row) vector result of premultiplying this by the vector `v`.

  Parameters:
    `v` - the row vector to premultiply by
  Returns:
    v*this
  Throws:
    `IllegalArgumentException` - if rowDimension != v.size()

### preMultiply

    RealVector preMultiply(RealVector v)
                           throws IllegalArgumentException

  Returns the (row) vector result of premultiplying this by the vector `v`.

  Parameters:
    `v` - the row vector to premultiply by
  Returns:
    v*this
  Throws:
    `IllegalArgumentException` - if rowDimension != v.size()

### walkInRowOrder

    double walkInRowOrder(RealMatrixChangingVisitor visitor)
                          throws MatrixVisitorException

  Visit (and possibly change) all matrix entries in row order.

  Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
  See Also:
    `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

    double walkInRowOrder(RealMatrixPreservingVisitor visitor)
                          throws MatrixVisitorException

  Visit (but don't change) all matrix entries in row order.

  Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

    double walkInRowOrder(RealMatrixChangingVisitor visitor,
                          int startRow,
                          int endRow,
                          int startColumn,
                          int endColumn)
                          throws MatrixIndexException,
                                 MatrixVisitorException

  Visit (and possibly change) some matrix entries in row order.

  Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
    `MatrixIndexException` - if the indices are not valid
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

    double walkInRowOrder(RealMatrixPreservingVisitor visitor,
                          int startRow,
                          int endRow,
                          int startColumn,
                          int endColumn)
                          throws MatrixIndexException,
                                 MatrixVisitorException

  Visit (but don't change) some matrix entries in row order.

  Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
    `MatrixIndexException` - if the indices are not valid
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInColumnOrder

    double walkInColumnOrder(RealMatrixChangingVisitor visitor)
                             throws MatrixVisitorException

  Visit (and possibly change) all matrix entries in column order.

  Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInColumnOrder

    double walkInColumnOrder(RealMatrixPreservingVisitor visitor)
                             throws MatrixVisitorException

  Visit (but don't change) all matrix entries in column order.

  Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInColumnOrder

    double walkInColumnOrder(RealMatrixChangingVisitor visitor,
                             int startRow,
                             int endRow,
                             int startColumn,
                             int endColumn)
                             throws MatrixIndexException,
                                    MatrixVisitorException

  Visit (and possibly change) some matrix entries in column order.

  Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
    `MatrixIndexException` - if the indices are not valid
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInColumnOrder

    double walkInColumnOrder(RealMatrixPreservingVisitor visitor,
                             int startRow,
                             int endRow,
                             int startColumn,
                             int endColumn)
                             throws MatrixIndexException,
                                    MatrixVisitorException

  Visit (but don't change) some matrix entries in column order.

  Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
    `MatrixIndexException` - if the indices are not valid
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

    double walkInOptimizedOrder(RealMatrixChangingVisitor visitor)
                                throws MatrixVisitorException

  Visit (and possibly change) all matrix entries using the fastest possible order.

  The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

    double walkInOptimizedOrder(RealMatrixPreservingVisitor visitor)
                                throws MatrixVisitorException

  Visit (but don't change) all matrix entries using the fastest possible order.

  The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

    double walkInOptimizedOrder(RealMatrixChangingVisitor visitor,
                                int startRow,
                                int endRow,
                                int startColumn,
                                int endColumn)
                                throws MatrixIndexException,
                                       MatrixVisitorException

  Visit (and possibly change) some matrix entries using the fastest possible order.

  The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index (inclusive)
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
    `MatrixIndexException` - if the indices are not valid
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

    double walkInOptimizedOrder(RealMatrixPreservingVisitor visitor,
                                int startRow,
                                int endRow,
                                int startColumn,
                                int endColumn)
                                throws MatrixIndexException,
                                       MatrixVisitorException

  Visit (but don't change) some matrix entries using the fastest possible order.

  The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index (inclusive)
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `MatrixVisitorException` - if the visitor cannot process an entry
    `MatrixIndexException` - if the indices are not valid
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`

### solve

    @Deprecated
    double[] solve(double[] b)
                   throws IllegalArgumentException,
                          InvalidMatrixException

  Deprecated. as of release 2.0, replaced by `DecompositionSolver.solve(double[])`

  Returns the solution vector for a linear system with coefficient matrix = this and constant vector = `b`.

  Parameters:
    `b` - constant vector
  Returns:
    vector of solution values to AX = b, where A is *this
  Throws:
    `IllegalArgumentException` - if this.rowDimension != b.length
    `InvalidMatrixException` - if this matrix is not square or is singular

### solve

    @Deprecated
    RealMatrix solve(RealMatrix b)
                     throws IllegalArgumentException,
                            InvalidMatrixException

  Deprecated. as of release 2.0, replaced by `DecompositionSolver.solve(RealMatrix)`

  Returns a matrix of (column) solution vectors for linear systems with coefficient matrix = this and constant vectors = columns of `b`.

  Parameters:
    `b` - matrix of constant vectors forming RHS of linear systems to to solve
  Returns:
    matrix of solution vectors
  Throws:
    `IllegalArgumentException` - if this.rowDimension != row dimension
    `InvalidMatrixException` - if this matrix is not square or is singular

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2011 The Apache Software Foundation. All Rights Reserved.